/*Canopy - The next generation of stoner streaming software
Copyright (C) 2024-2025 Rainbownapkin and the TTN Community

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.*/

//npm imports
const {validationResult, matchedData} = require('express-validator');

//local imports
const {exceptionHandler, errorHandler} = require('../../../utils/loggerUtils');
const emoteModel = require('../../../schemas/emoteSchema');
const linkUtils = require('../../../utils/linkUtils');

module.exports.get = async function(req, res){
    try{
        const emoteList = await emoteModel.getEmotes();

        res.status(200);
        return res.send(emoteList);
    }catch(err){
        return exceptionHandler(res, err);
    }
}

module.exports.post = async function(req, res){
    try{
        //get validation error results
        const validResult = validationResult(req);

        //if they're empty
        if(validResult.isEmpty()){
            //get matched data
            const {name, link} = matchedData(req);
            //query for existing emote
            const emoteDB = await emoteModel.findOne({name});

            //if we have one
            if(emoteDB != null){
                //Throw a shit fit
                return errorHandler(res, `Emote [${name}] already exists!`);
            }

            //Initialize the emote object from linkUtils
            var emoteObj = await linkUtils.markLink(link);

            //If we didn't get a valid image/video file
            if(emoteObj.type != 'image' && emoteObj.type != 'video'){
                //AAAAAAAAAAAAAAAAAA
                return errorHandler(res, 'URL either does not lead to a valid image/video file, or leads to one that is larger than 4MB');
            }


            //Add the name to the emoteObj
            emoteObj.name = name;

            //Create the emote document
            await emoteModel.create(emoteObj);

            //Return the updated command list
            res.status(200);
            return res.send(await emoteModel.getEmotes());
        }else{
            //otherwise scream
            res.status(400);
            return res.send({errors: validResult.array()})
        }
    }catch(err){
        return exceptionHandler(res, err);
    }
}

module.exports.delete = async function(req, res){
    try{
        //get validation error results
        const validResult = validationResult(req);

        //if they're empty
        if(validResult.isEmpty()){
            //Pull name from sanatized/validated input
            const {name} = matchedData(req);
            //query for existing emote
            const emoteDB = await emoteModel.findOne({name});

            //if we don't have one
            if(emoteDB == null){
                //Throw a shit fit
                return errorHandler(res, `Cannot delete non-existant emote: [${name}]!`);
            }

            await emoteDB.deleteOne();

            //Return the updated command list
            res.status(200);
            return res.send(await emoteModel.getEmotes());
        }else{
            //otherwise scream
            res.status(400);
            return res.send({errors: validResult.array()})
        }
    }catch(err){
        return exceptionHandler(res, err);
    }
}